/** File "gg_page_dimensions.h" 
 *
 */

#ifndef __GG_PAGE_DIMENSIONS_H_
#define __GG_PAGE_DIMENSIONS_H_

typedef struct _PageDimensions PageDimensions;

struct _PageDimensions {
  int       device_id;   	 /* the index in device_table[] */
  GtkWidget *w_psync;
  GtkWidget *w_orient;
  GtkWidget *w_format;
  GtkWidget *w_page_x;
  GtkWidget *w_page_y;
  GtkWidget *w_page_units;
  GtkWidget *w_dev_dpi;
  PageUnit  page_units;        /* PAGE_UNITS_PIXELS, PAGE_UNITS_INCHES, PAGE_UNITS_CM */
};


void gg_page_dimensions_new    (GtkWidget *w_parent ,PageDimensions *pdim);
void gg_page_dimensions_update (PageDimensions *pdim);
void gg_page_dimensions_apply  (PageDimensions *pdim);

#endif /* __GG_PAGE_DIMENSIONS_H_ */
