
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define Calloc(n,t)	(t *)calloc((unsigned)(n),sizeof(t))
#define Free(p)		free((char *)(p))

/* the mapping from f77 to C intermediate code -- may be machine dependent
 * the first definition satisfies lint's narrowminded preprocessing & should
 * stay the same for all implementations.  The __STDC__ definition is for
 * ANSI standard conforming C compilers. The #else definition should
 * generate the version of the fortran subroutine & common block names x
 * handed to the local loader; e.g., "x_" in system V, Berkeley & 9th edition
 */

#define TRUE  1
#define FALSE 0

/* return codes */
#define RETURN_SUCCESS (0)
#define RETURN_FAILURE (1)

#define NULL_ENTRY          ((int *)NULL)

//scipy 
#define Sint int
//scipy #define R_alloc realloc

#define	NL_GAUSSIAN	1
#define NL_SYMMETRIC	0

void loess_raw (double *y ,double *x ,double *weights ,double *robust 
		,Sint *d ,Sint *n ,double *span ,Sint *degree 
		,Sint *nonparametric ,Sint *drop_square ,Sint *sum_drop_sqr ,double *cell 
		,char **surf_stat ,double *surface ,Sint *parameter ,Sint *a 
		,double *xi ,double *vert ,double *vval ,double *diagonal
		,double *trL ,double *one_delta ,double *two_delta ,Sint *setLf);

void loess_prune (Sint *parameter ,Sint *a ,double *xi ,double *vert ,double *vval);
