/** File cairo_drv.h
 */
#ifndef __CAIRO_DRV_
#define __CAIRO_DRV_

gboolean tcr_configure_event_CB (GtkWidget *w ,GdkEventConfigure *event ,gpointer data);  
gboolean tcr_expose_event_CB 	(GtkWidget *w ,GdkEventExpose *event    ,gpointer data);
void cr_draw_rectangle (gboolean filled ,gint x ,gint y ,gint width ,gint height);
void cr_handles (view v ,int nh ,int center);  // gg_handles

/*  int  dummy_initgraphics  (void); */
int tcr_gtk_init_driver  (void);
int tcr_gtk_initgraphics (void);
int hcr_eps_initgraphics (void);
int hcr_pdf_initgraphics (void);
int hcr_png_initgraphics (void);
int hcr_svg_initgraphics (void);

/* functions for the standard interface */
void cr_drawarc       (VPoint vp1 ,VPoint vp2 ,int a1 ,int a2);
void cr_drawpixel     (VPoint vp);
void cr_drawpolyline  (VPoint *vps ,int n ,int mode);
void cr_fillarc       (VPoint vp1 ,VPoint vp2 ,int a1 ,int a2 ,int mode);
void cr_fillpolygon   (VPoint *vps ,int nc);
void cr_leavegraphics (void);
void cr_putpixbuf     (void *data ,VPoint *vp1 ,VPoint *vp2 ,int scaling_type ,double *scale_x ,double *scale_y);
void cr_putpixmap     (VPoint vp ,int width ,int height ,char *databits ,int pixmap_bpp ,int bitmap_pad ,int pixmap_type);
void cr_puttext       (VPoint vp ,char *s ,int len ,int font ,TextMatrix *tm ,int underline ,int overline ,int kerning);
void cr_setfrgbcolor  (double red ,double green ,double blue);
void cr_updatecmap    (void);


int cr_op_parser (char *opstring);

#endif /* __CAIRO_DRV_ */

